
var Complete =
{
	colors : ['AliceBlue','AntiqueWhite','Aqua','Aquamarine','Azure','Beige','Bisque','Black','BlanchedAlmond','Blue','BlueViolet','Brown','Burywood','CadetBlue','Chartreuse','Chocolate','Coral','CornflowerBlue','Cornsilk','Crimson','Cyan','DarkBlue','DarkCyan','DarkGoldenrod','DarkGray','DarkGreen','DarkKhaki','DarkMagenta','DarkOliveGreen','DarkOrange','DarkOrchid','DarkRed','DarkSalmon','DarkSeaGreen','DarkSlateBlue','DarkSlateGray','DarkTurquoise','DarkViolet','DeepPink','DeepSkyBlue','DimGray','DodgerBlue','FireBrick','FloralWhite','ForestGreen','Fuchsia','Gainsboro','GhostWhite','Gold','Golodenrod','Gray','Green','GreenYellow','Honeydew','HotPink','IndianRed','Indigo','Ivory','Khaki','Lavender','LavenderBlush','LawnGreen','LemonChiffon','LightBlue','LightCoral','LightCyan','LightGoldenrodYellow','LightGreen','LightGrey','LightPink','LightSalmon','LightSeaGreen','LightSkyBlue','LightSlateGray','LightSteelBlue','LightYellow','Lime','LimeGreen','Linen','Magenta','Maroon','MediumBlue','MediumOrchid','MediumPurple','MediumSeaGreen','MediumSlateBlue','MediumSpringGreen','MediumTurquoise','MediumVioletRed','MideumAquamarine','MidinightBlue','MintCream','MistyRose','Moccasin','NavajoWhite','Navy','OldLace','Olive','OliveDrab','Orange','OrangeRed','Orchid','PaleGoldenrod','PaleGreen','PaleTurquoise','PaleVioletRed','PapayaWhip','PeachPuff','Peru','Pink','Plum','PowderBlue','Purple','Red','RosyBrown','RoyalBlue','SaddleBrown','Salmon','SandyBrown','SeaGreen','Seashell','Sienna','Silver','SkyBlue','SlateBlue','SlateGray','Snow','SpringGreen','SteelBlue','Tan','Teal','Thistle','Tomato','Turquoise','Violet','Wheat','White','WhiteSmoke','Yellow','YellowGreen'],
	
	lastSelectionStart : 0,
	run : function(e, input, value)
	{
		if ( _event.ctrlKey(e) ) return;
		this.borc    = input.id.match(/[bc]/);
		this.input   = document.getElementById(input.id);
		this.keyCode = _event.keyCode(e);
		this.keyChar = _event.keyChar(e).match(/^[A-Z]$/);
		value = value.replace(/(^[^A-Z~]|(.)[^A-Z]+)/gi, '$2');
		
		var eName;
		switch (this.keyCode) {
			case  8: eName = 'BS';    break;
			case 13: eName = 'ENTER'; break;
			case 27: eName = 'ESC';   break;
			case 37: eName = 'LEFT';  break;
			case 38: eName = 'UP';    break;
			case 39: eName = 'RIGHT'; break;
			case 40: eName = 'DOWN';  break;
			default: eName = (this.keyChar ? 'CHAR' : null);
			}
		switch (eName) {
			case 'ESC':
			case 'ENTER':
				this.close(eName);
				break;
			case 'UP':
			case 'DOWN':
				this.focus(eName, value);
				break;
			case 'LEFT':
			case "RIGHT":
				break;
			case 'BS':
			case 'CHAR':
				this.reset();
				this.beforeValue = value;
				this.create(eName, value);
				break;
			}
	},
	
	create : function(eName, value)
	{
		this.isTilde = (value.charAt(0) == '~');
		if (value == '' || value == '~' || this.isTilde && value.length < 3)
			return this.reset();
		
		var cUL = document.createElement('ul');
		var regexp = new RegExp(!this.isTilde ? '^'+value+'.*$' : '^.*'+value.substr(1)+'.*$', 'mgi');
		var values = this.colors.join('\n').match(regexp);
		
		if (!values) return this.reset();
		for (var i=0, cLI; i<values.length; i++)
		{
			cLI = document.createElement('li'); var _this=this; if (UA.WinIE) {
			cLI.onmouseout  = function() { _this.setHighlight(this, false) };
			cLI.onmouseover = function() { _this.setHighlight(this, true)  }; }
			cLI.onclick     = function() { _this.close(this.firstChild.data) };
			cLI.style.borderRightColor = colors1[values[i].toLowerCase()];
			cLI.appendChild(document.createTextNode(values[i])); cUL.appendChild(cLI);
		}
		cUL.id = 'CompleteContainer';
		this.input.parentNode.insertBefore(cUL, this.input.nextSibling);
		this.items = this.input.nextSibling.getElementsByTagName('li');
		
		if (eName != 'CHAR' || this.isTilde) return;
		else if (values.length == 1 && value.length > 1) this.close('ONE');
		else if (values.length  > 1 && this.items.length > 1)
		{
			this.lastSelectionStart = value.length;
			this.input.value = this.items[0].firstChild.data;
			this.setSelection(value.length); this.fNum = 0;
			this.setHighlight(this.items[0], true);
		}
	},
	
	fNum : -1,
	focus : function(eName, value)
	{
		if (!this.hasContainer()) {
		    this.create('CHAR', value); this.fNum = -1 }
		if (this.fNum == -1) this.beforeValue = value;
		
		var max = this.items.length-1, item;
		try {
			item = this.items[this.fNum];
			this.setHighlight(item, false);
		}
		catch (e) {};
		switch (eName) {
			case 'UP':
				this.fNum--;
				if (this.fNum <  0 ) return this.close('UNDO');
				break;
			case 'DOWN':
				this.fNum++;
				if (this.fNum > max) this.fNum = 0;
				break;
			}
		item = this.items[this.fNum];
		this.setHighlight(item, true);
		
		if (this.lastSelectionStart > 0 && !this.isTilde) {
			this.input.value = item.firstChild.data;
			this.setSelection(this.lastSelectionStart);
		}
		else if (max > 0 && !this.isTilde) {
			this.input.value = item.firstChild.data;
			this.setSelection(this.beforeValue.length);
		}
		else if (this.isTilde) {
			this.input.value = '~'+item.firstChild.data;
			this.setSelection(1);
		}
	},
	
	close : function(eName)
	{
		switch (eName) {
			case 'BLUR':
				return this.reset();
			case 'ESC':
			case 'UNDO': if (this.hasContainer())
				this.input.value = this.beforeValue; else
				this.input.value = _last['x11'+this.borc];
				this.setSelection('end'); return this.reset();
			case 'ENTER':
				if (this.items.length == 1)
				this.input.value = this.items[0].firstChild.data;
				break;
			case 'ONE':
				if (this.keyCode == 8) return this.reset();
				this.input.value = this.items[0].firstChild.data;
				break;
			default:
				this.input.value = eName;
			}
		_x11color.input(this.borc);
		this.setSelection('end');
		this.reset(); return false;
	},
	
	reset : function()
	{
		if (this.hasContainer())
		this.input.parentNode.removeChild(this.input.nextSibling);
		this.fNum = -1; this.lastSelectionStart = 0;
	},
	
	blur : function(e, borc)
	{
		borc = (borc ? borc : this.lastFocus);
		if (_event.keyCode(e) == 9) this.close('BLUR');
		else if (_event.target(e).id.match(/^x11/) || !borc) return;
		else this.close('BLUR'); this.lastFocus = null;
		_x11color.input(borc);
	},
	
	setHighlight : function(obj, flag)
	{
		if (!(obj && obj.style)) return;
		obj.className = (flag ? 'highlight' : '');
	},
	
	setSelection : function(st)
	{
		if (UA.Opera7) return;
		var obj = this.input;
		var ed  = obj.value.length;
		switch (st) {
			case 'start': st = 0; ed = 0; break;
			case 'end'  : st = obj.value.length; break;
			}
		if (document.all) {
			var
			range = obj.createTextRange();
			range.moveStart("character", st);
			range.moveEnd("character", ed - obj.value.length);
			range.select();
			}
		else obj.setSelectionRange(st, ed);
	},
	
	hasContainer : function()
	{
		return (
			this.input && this.input.nextSibling &&
			this.input.nextSibling.hasChildNodes() )
		;
	}
};

